<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Transitional//EN" "http://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd">
<html xmlns="http://www.w3.org/1999/xhtml" xml:lang="en" lang="en">
<head><meta http-equiv="content-type" content="text/html; charset=UTF-8" />
<title>IOUtils xref</title>
<link type="text/css" rel="stylesheet" href="../../../../stylesheet.css" />
</head>
<body>
<div id="overview"><a href="../../../../../apidocs/net/sf/debianmaven/utils/IOUtils.html">View Javadoc</a></div><pre>
<a class="jxr_linenumber" name="L1" href="#L1">1</a>   <em class="jxr_comment">/*</em>
<a class="jxr_linenumber" name="L2" href="#L2">2</a>   <em class="jxr_comment"> *   This program is free software: you can redistribute it and/or modify</em>
<a class="jxr_linenumber" name="L3" href="#L3">3</a>   <em class="jxr_comment"> *   it under the terms of the GNU General Public License as published by</em>
<a class="jxr_linenumber" name="L4" href="#L4">4</a>   <em class="jxr_comment"> *   the Free Software Foundation, either version 3 of the License, or</em>
<a class="jxr_linenumber" name="L5" href="#L5">5</a>   <em class="jxr_comment"> *   (at your option) any later version.</em>
<a class="jxr_linenumber" name="L6" href="#L6">6</a>   <em class="jxr_comment"> *</em>
<a class="jxr_linenumber" name="L7" href="#L7">7</a>   <em class="jxr_comment"> *   This program is distributed in the hope that it will be useful,</em>
<a class="jxr_linenumber" name="L8" href="#L8">8</a>   <em class="jxr_comment"> *   but WITHOUT ANY WARRANTY; without even the implied warranty of</em>
<a class="jxr_linenumber" name="L9" href="#L9">9</a>   <em class="jxr_comment"> *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the</em>
<a class="jxr_linenumber" name="L10" href="#L10">10</a>  <em class="jxr_comment"> *   GNU General Public License for more details.</em>
<a class="jxr_linenumber" name="L11" href="#L11">11</a>  <em class="jxr_comment"> *</em>
<a class="jxr_linenumber" name="L12" href="#L12">12</a>  <em class="jxr_comment"> *   You should have received a copy of the GNU General Public License</em>
<a class="jxr_linenumber" name="L13" href="#L13">13</a>  <em class="jxr_comment"> *   along with this program.  If not, see &lt;<a href="http://www.gnu.org/licenses/&gt;" target="alexandria_uri">http://www.gnu.org/licenses/&gt;</a>.</em>
<a class="jxr_linenumber" name="L14" href="#L14">14</a>  <em class="jxr_comment"> */</em>
<a class="jxr_linenumber" name="L15" href="#L15">15</a>  
<a class="jxr_linenumber" name="L16" href="#L16">16</a>  <em class="jxr_comment">/*</em>
<a class="jxr_linenumber" name="L17" href="#L17">17</a>  <em class="jxr_comment"> * FileUtils.java</em>
<a class="jxr_linenumber" name="L18" href="#L18">18</a>  <em class="jxr_comment"> * Copyright (C) 2019 University of Waikato, Hamilton, NZ</em>
<a class="jxr_linenumber" name="L19" href="#L19">19</a>  <em class="jxr_comment"> */</em>
<a class="jxr_linenumber" name="L20" href="#L20">20</a>  
<a class="jxr_linenumber" name="L21" href="#L21">21</a>  <strong class="jxr_keyword">package</strong> net.sf.debianmaven.utils;
<a class="jxr_linenumber" name="L22" href="#L22">22</a>  
<a class="jxr_linenumber" name="L23" href="#L23">23</a>  <strong class="jxr_keyword">import</strong> net.sf.debianmaven.FixPermission;
<a class="jxr_linenumber" name="L24" href="#L24">24</a>  <strong class="jxr_keyword">import</strong> org.apache.maven.plugin.logging.Log;
<a class="jxr_linenumber" name="L25" href="#L25">25</a>  
<a class="jxr_linenumber" name="L26" href="#L26">26</a>  <strong class="jxr_keyword">import</strong> java.io.File;
<a class="jxr_linenumber" name="L27" href="#L27">27</a>  <strong class="jxr_keyword">import</strong> java.io.IOException;
<a class="jxr_linenumber" name="L28" href="#L28">28</a>  <strong class="jxr_keyword">import</strong> java.nio.file.FileSystems;
<a class="jxr_linenumber" name="L29" href="#L29">29</a>  <strong class="jxr_keyword">import</strong> java.nio.file.Path;
<a class="jxr_linenumber" name="L30" href="#L30">30</a>  <strong class="jxr_keyword">import</strong> java.util.List;
<a class="jxr_linenumber" name="L31" href="#L31">31</a>  <strong class="jxr_keyword">import</strong> java.util.regex.Pattern;
<a class="jxr_linenumber" name="L32" href="#L32">32</a>  
<a class="jxr_linenumber" name="L33" href="#L33">33</a>  <em class="jxr_javadoccomment">/**</em>
<a class="jxr_linenumber" name="L34" href="#L34">34</a>  <em class="jxr_javadoccomment"> * Helper class for I/O related operations.</em>
<a class="jxr_linenumber" name="L35" href="#L35">35</a>  <em class="jxr_javadoccomment"> *</em>
<a class="jxr_linenumber" name="L36" href="#L36">36</a>  <em class="jxr_javadoccomment"> * @author FracPete (fracpete at waikato dot ac dot nz)</em>
<a class="jxr_linenumber" name="L37" href="#L37">37</a>  <em class="jxr_javadoccomment"> */</em>
<a class="jxr_linenumber" name="L38" href="#L38">38</a>  <strong class="jxr_keyword">public</strong> <strong class="jxr_keyword">class</strong> <a href="../../../../net/sf/debianmaven/utils/IOUtils.html">IOUtils</a>
<a class="jxr_linenumber" name="L39" href="#L39">39</a>  {
<a class="jxr_linenumber" name="L40" href="#L40">40</a>  
<a class="jxr_linenumber" name="L41" href="#L41">41</a>  	<em class="jxr_javadoccomment">/**</em>
<a class="jxr_linenumber" name="L42" href="#L42">42</a>  <em class="jxr_javadoccomment">	 * Applies the patterns to fix file permissions.</em>
<a class="jxr_linenumber" name="L43" href="#L43">43</a>  <em class="jxr_javadoccomment">	 * @param log for logging output</em>
<a class="jxr_linenumber" name="L44" href="#L44">44</a>  <em class="jxr_javadoccomment">	 * @param dir the directory to process</em>
<a class="jxr_linenumber" name="L45" href="#L45">45</a>  <em class="jxr_javadoccomment">	 * @param fixPermissions the permissions to apply</em>
<a class="jxr_linenumber" name="L46" href="#L46">46</a>  <em class="jxr_javadoccomment">	 * @throws IOException if application of permissions fails</em>
<a class="jxr_linenumber" name="L47" href="#L47">47</a>  <em class="jxr_javadoccomment">	 */</em>
<a class="jxr_linenumber" name="L48" href="#L48">48</a>  	<strong class="jxr_keyword">public</strong> <strong class="jxr_keyword">static</strong> <strong class="jxr_keyword">void</strong> applyFixPermissions(Log log, File dir, List&lt;FixPermission&gt; fixPermissions) <strong class="jxr_keyword">throws</strong> IOException
<a class="jxr_linenumber" name="L49" href="#L49">49</a>  	{
<a class="jxr_linenumber" name="L50" href="#L50">50</a>  		log.debug(<span class="jxr_string">"Fixing permissions in: "</span> + dir);
<a class="jxr_linenumber" name="L51" href="#L51">51</a>  
<a class="jxr_linenumber" name="L52" href="#L52">52</a>  		<em class="jxr_comment">// directory itself</em>
<a class="jxr_linenumber" name="L53" href="#L53">53</a>  		<strong class="jxr_keyword">for</strong> (FixPermission fixPermission: fixPermissions)
<a class="jxr_linenumber" name="L54" href="#L54">54</a>  		{
<a class="jxr_linenumber" name="L55" href="#L55">55</a>  			<strong class="jxr_keyword">if</strong> (fixPermission.appliesTo(dir))
<a class="jxr_linenumber" name="L56" href="#L56">56</a>  			{
<a class="jxr_linenumber" name="L57" href="#L57">57</a>  				log.debug(<span class="jxr_string">"'"</span> + fixPermission + <span class="jxr_string">"' applies to: "</span> + dir);
<a class="jxr_linenumber" name="L58" href="#L58">58</a>  				fixPermission.applyTo(dir);
<a class="jxr_linenumber" name="L59" href="#L59">59</a>  			}
<a class="jxr_linenumber" name="L60" href="#L60">60</a>  		}
<a class="jxr_linenumber" name="L61" href="#L61">61</a>  
<a class="jxr_linenumber" name="L62" href="#L62">62</a>  		<em class="jxr_comment">// iterate files/dirs</em>
<a class="jxr_linenumber" name="L63" href="#L63">63</a>  		File[] files = dir.listFiles();
<a class="jxr_linenumber" name="L64" href="#L64">64</a>  		<strong class="jxr_keyword">if</strong> (files != <strong class="jxr_keyword">null</strong>)
<a class="jxr_linenumber" name="L65" href="#L65">65</a>  		{
<a class="jxr_linenumber" name="L66" href="#L66">66</a>  			<strong class="jxr_keyword">for</strong> (File file: files)
<a class="jxr_linenumber" name="L67" href="#L67">67</a>  			{
<a class="jxr_linenumber" name="L68" href="#L68">68</a>  				<strong class="jxr_keyword">if</strong> (file.isDirectory())
<a class="jxr_linenumber" name="L69" href="#L69">69</a>  					applyFixPermissions(log, file, fixPermissions);
<a class="jxr_linenumber" name="L70" href="#L70">70</a>  				<strong class="jxr_keyword">else</strong>
<a class="jxr_linenumber" name="L71" href="#L71">71</a>  				{
<a class="jxr_linenumber" name="L72" href="#L72">72</a>  					<strong class="jxr_keyword">for</strong> (FixPermission fixPermission: fixPermissions)
<a class="jxr_linenumber" name="L73" href="#L73">73</a>  					{
<a class="jxr_linenumber" name="L74" href="#L74">74</a>  						<strong class="jxr_keyword">if</strong> (fixPermission.appliesTo(file))
<a class="jxr_linenumber" name="L75" href="#L75">75</a>  						{
<a class="jxr_linenumber" name="L76" href="#L76">76</a>  							log.debug(<span class="jxr_string">"'"</span> + fixPermission + <span class="jxr_string">"' applies to: "</span> + file);
<a class="jxr_linenumber" name="L77" href="#L77">77</a>  							fixPermission.applyTo(file);
<a class="jxr_linenumber" name="L78" href="#L78">78</a>  						}
<a class="jxr_linenumber" name="L79" href="#L79">79</a>  					}
<a class="jxr_linenumber" name="L80" href="#L80">80</a>  				}
<a class="jxr_linenumber" name="L81" href="#L81">81</a>  			}
<a class="jxr_linenumber" name="L82" href="#L82">82</a>  		}
<a class="jxr_linenumber" name="L83" href="#L83">83</a>  	}
<a class="jxr_linenumber" name="L84" href="#L84">84</a>  
<a class="jxr_linenumber" name="L85" href="#L85">85</a>  	<em class="jxr_javadoccomment">/**</em>
<a class="jxr_linenumber" name="L86" href="#L86">86</a>  <em class="jxr_javadoccomment">	 * Copies or moves files and directories (recursively).</em>
<a class="jxr_linenumber" name="L87" href="#L87">87</a>  <em class="jxr_javadoccomment">	 * If targetLocation does not exist, it will be created.</em>
<a class="jxr_linenumber" name="L88" href="#L88">88</a>  <em class="jxr_javadoccomment">	 * &lt;br&gt;&lt;br&gt;</em>
<a class="jxr_linenumber" name="L89" href="#L89">89</a>  <em class="jxr_javadoccomment">	 * Original code from &lt;a href="<a href="http://www.java-tips.org/java-se-tips/java.io/how-to-copy-a-directory-from-one-location-to-another-loc.html" target="alexandria_uri">http://www.java-tips.org/java-se-tips/java.io/how-to-copy-a-directory-from-one-location-to-another-loc.html</a>" target="_blank"&gt;Java-Tips.org&lt;/a&gt;.</em>
<a class="jxr_linenumber" name="L90" href="#L90">90</a>  <em class="jxr_javadoccomment">	 *</em>
<a class="jxr_linenumber" name="L91" href="#L91">91</a>  <em class="jxr_javadoccomment">	 * @param log for logging</em>
<a class="jxr_linenumber" name="L92" href="#L92">92</a>  <em class="jxr_javadoccomment">	 * @param sourceLocation the source file/dir</em>
<a class="jxr_linenumber" name="L93" href="#L93">93</a>  <em class="jxr_javadoccomment">	 * @param targetLocation the target file/dir</em>
<a class="jxr_linenumber" name="L94" href="#L94">94</a>  <em class="jxr_javadoccomment">	 * @param include the regular expression pattern for including files/dirs</em>
<a class="jxr_linenumber" name="L95" href="#L95">95</a>  <em class="jxr_javadoccomment">	 * @param fileCopy performs the actual copying of source/target file</em>
<a class="jxr_linenumber" name="L96" href="#L96">96</a>  <em class="jxr_javadoccomment">	 * @return false if failed to delete when moving or failed to create target directory</em>
<a class="jxr_linenumber" name="L97" href="#L97">97</a>  <em class="jxr_javadoccomment">	 * @throws IOException	if copying/moving fails</em>
<a class="jxr_linenumber" name="L98" href="#L98">98</a>  <em class="jxr_javadoccomment">	 */</em>
<a class="jxr_linenumber" name="L99" href="#L99">99</a>  	<strong class="jxr_keyword">public</strong> <strong class="jxr_keyword">static</strong> <strong class="jxr_keyword">boolean</strong> copy(Log log, File sourceLocation, File targetLocation, Pattern include, <a href="../../../../net/sf/debianmaven/utils/FileCopy.html">FileCopy</a> fileCopy) <strong class="jxr_keyword">throws</strong> IOException
<a class="jxr_linenumber" name="L100" href="#L100">100</a> 	{
<a class="jxr_linenumber" name="L101" href="#L101">101</a> 		String[] children;
<a class="jxr_linenumber" name="L102" href="#L102">102</a> 		<strong class="jxr_keyword">int</strong> i;
<a class="jxr_linenumber" name="L103" href="#L103">103</a> 		Path source;
<a class="jxr_linenumber" name="L104" href="#L104">104</a> 		Path target;
<a class="jxr_linenumber" name="L105" href="#L105">105</a> 
<a class="jxr_linenumber" name="L106" href="#L106">106</a> 		<strong class="jxr_keyword">if</strong> (sourceLocation.isDirectory()) {
<a class="jxr_linenumber" name="L107" href="#L107">107</a> 			log.debug(<span class="jxr_string">"Entering source dir: "</span> + sourceLocation);
<a class="jxr_linenumber" name="L108" href="#L108">108</a> 			<strong class="jxr_keyword">if</strong> (!targetLocation.exists()) {
<a class="jxr_linenumber" name="L109" href="#L109">109</a> 				<strong class="jxr_keyword">if</strong> (!targetLocation.mkdirs() &amp;&amp; !targetLocation.exists())
<a class="jxr_linenumber" name="L110" href="#L110">110</a> 				{
<a class="jxr_linenumber" name="L111" href="#L111">111</a> 					log.error(<span class="jxr_string">"Failed to create target directory: "</span> + targetLocation);
<a class="jxr_linenumber" name="L112" href="#L112">112</a> 					<strong class="jxr_keyword">return</strong> false;
<a class="jxr_linenumber" name="L113" href="#L113">113</a> 				}
<a class="jxr_linenumber" name="L114" href="#L114">114</a> 			}
<a class="jxr_linenumber" name="L115" href="#L115">115</a> 
<a class="jxr_linenumber" name="L116" href="#L116">116</a> 			children = sourceLocation.list();
<a class="jxr_linenumber" name="L117" href="#L117">117</a> 			<strong class="jxr_keyword">for</strong> (i = 0; i &lt; children.length; i++) {
<a class="jxr_linenumber" name="L118" href="#L118">118</a> 				<strong class="jxr_keyword">if</strong> (include.matcher(<strong class="jxr_keyword">new</strong> File(sourceLocation.getAbsoluteFile(), children[i]).getAbsolutePath()).matches())
<a class="jxr_linenumber" name="L119" href="#L119">119</a> 				{
<a class="jxr_linenumber" name="L120" href="#L120">120</a> 					<strong class="jxr_keyword">if</strong> (!copy(
<a class="jxr_linenumber" name="L121" href="#L121">121</a> 						log,
<a class="jxr_linenumber" name="L122" href="#L122">122</a> 						<strong class="jxr_keyword">new</strong> File(sourceLocation.getAbsoluteFile(), children[i]),
<a class="jxr_linenumber" name="L123" href="#L123">123</a> 						<strong class="jxr_keyword">new</strong> File(targetLocation.getAbsoluteFile(), children[i]),
<a class="jxr_linenumber" name="L124" href="#L124">124</a> 						include, fileCopy))
<a class="jxr_linenumber" name="L125" href="#L125">125</a> 						<strong class="jxr_keyword">return</strong> false;
<a class="jxr_linenumber" name="L126" href="#L126">126</a> 				}
<a class="jxr_linenumber" name="L127" href="#L127">127</a> 			}
<a class="jxr_linenumber" name="L128" href="#L128">128</a> 
<a class="jxr_linenumber" name="L129" href="#L129">129</a> 			<strong class="jxr_keyword">return</strong> <strong class="jxr_keyword">true</strong>;
<a class="jxr_linenumber" name="L130" href="#L130">130</a> 		}
<a class="jxr_linenumber" name="L131" href="#L131">131</a> 		<strong class="jxr_keyword">else</strong> {
<a class="jxr_linenumber" name="L132" href="#L132">132</a> 			source = FileSystems.getDefault().getPath(sourceLocation.getAbsolutePath());
<a class="jxr_linenumber" name="L133" href="#L133">133</a> 			<strong class="jxr_keyword">if</strong> (include.matcher(source.toAbsolutePath().toString()).matches())
<a class="jxr_linenumber" name="L134" href="#L134">134</a> 			{
<a class="jxr_linenumber" name="L135" href="#L135">135</a> 				<strong class="jxr_keyword">if</strong> (targetLocation.isDirectory())
<a class="jxr_linenumber" name="L136" href="#L136">136</a> 					target = FileSystems.getDefault().getPath(targetLocation.getAbsolutePath() + File.separator + sourceLocation.getName());
<a class="jxr_linenumber" name="L137" href="#L137">137</a> 				<strong class="jxr_keyword">else</strong>
<a class="jxr_linenumber" name="L138" href="#L138">138</a> 					target = FileSystems.getDefault().getPath(targetLocation.getAbsolutePath());
<a class="jxr_linenumber" name="L139" href="#L139">139</a> 				log.debug(<span class="jxr_string">"Copying '"</span> + sourceLocation + <span class="jxr_string">"' to '"</span> + target + <span class="jxr_string">"'"</span>);
<a class="jxr_linenumber" name="L140" href="#L140">140</a> 				fileCopy.copy(source, target);
<a class="jxr_linenumber" name="L141" href="#L141">141</a> 			}
<a class="jxr_linenumber" name="L142" href="#L142">142</a> 			<strong class="jxr_keyword">return</strong> <strong class="jxr_keyword">true</strong>;
<a class="jxr_linenumber" name="L143" href="#L143">143</a> 		}
<a class="jxr_linenumber" name="L144" href="#L144">144</a> 	}
<a class="jxr_linenumber" name="L145" href="#L145">145</a> }
</pre>
<hr/>
<div id="footer">Copyright &#169; 2012&#x2013;2019. All rights reserved.</div>
</body>
</html>
